import { Interface } from '@overflow/model/net/nic';
import { Selector, createSelector } from '@ngrx/store';

export interface State {
  interfaces: Interface[] | null;
  error: string | null;
  pending: boolean;
}

export const initialState: State = {
  interfaces: null,
  error: null,
  pending: false,
};


export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    selectInterfaces: createSelector(selector, (state: State) => state.interfaces),
    selectError: createSelector(selector, (state: State) => state.error),
    selectPending: createSelector(selector, (state: State) => state.pending),
  };
}
