import {
  Actions,
  ActionType,
} from './target.action';

import {
  State,
  initialState,
} from './target.state';

export function reducer(state: State = initialState, action: Actions): State {
  switch (action.type) {
    case ActionType.SetHosts: {
      return {
        ...state,
        hosts: action.payload,
      };
    }

    case ActionType.SetPorts: {
      return {
        ...state,
        ports: action.payload,
      };
    }

    case ActionType.SetServices: {
      return {
        ...state,
        services: action.payload,
      };
    }

    case ActionType.ChangeTargetDisplayType: {
      return {
        ...state,
        targetDisplayType: action.payload.targetDisplayType,
      };
    }

    case ActionType.RefreshTargetDisplay: {
      return {
        ...state,
        refreshTargetDisplay: action.payload,
      };
    }

    case ActionType.ChangeSelectedTarget: {
      return {
        ...state,
        selectedTarget: action.payload,
      };
    }

    case ActionType.ChangeTargetDisplayElementRef: {
      return {
        ...state,
        targetDisplayElementRef: action.payload.targetDisplayElementRef,
      };
    }

    default: {
      return state;
    }
  }
}
